//
//  peerguardnf (PeerGuard for Linux, BSD, and MacOS X systems)
//  Copyright (C) 2005 BitRot
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Id: HttpServer.h,v 1.2 2005/03/27 01:27:48 nullcontext Exp $

#ifndef HTTPSERVER_HEADER___
#define HTTPSERVER_HEADER___

#include <string>
#include <ext/hash_map>

namespace PG {
   
class BlockList;

struct string_hash : public __gnu_cxx::hash<char*>
{
   inline size_t operator()(const std::string& s) const
   {
      return __gnu_cxx::hash<char*>::operator()(s.c_str());
   }
};

typedef __gnu_cxx::hash_map<std::string,std::string,string_hash> CGIData;

int StartHttpServer(BlockList* blocklist);
int StopHttpServer();
void HandleHttpRequest(int sock, const std::string& req, BlockList* block_list);
int WriteData(int sock, const std::string& data);
void GetURLData(CGIData* data, const std::string& req_);

} // namespace PG

#endif // HTTPSERVER_HEADER___
