//
//  peerguardnf (PeerGuard for Linux, BSD, and MacOS X systems)
//  Copyright (C) 2005 bitrot
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Id: PeerGuard.h,v 1.2 2005/03/27 01:29:37 nullcontext Exp $

#ifndef PEERGUARD_HEADER___
#define PEERGUARD_HEADER___

#include "BlockList.h"

#include <ostream>

namespace PG {

struct PGPreferences
{
   std::string blocklistFilename;
   char allowedPorts[0xFFFF];
   std::string adminName;
   std::string adminPassword;

   PGPreferences()
      { memset(allowedPorts, 0, sizeof(allowedPorts)); }

   int Read(const std::string& filename);

   void AllowPort(uint16_t port) { allowedPorts[port] = 1; }
   void DisallowPort(uint16_t port) { allowedPorts[port] = 0; }
};

int CreateFirewallRules();
int DeleteFirewallRules();

void* BlockerThread(void* block_list_);
int StartBlockerThread(BlockList* blocklist);
int StopBlockerThread();

extern std::ostream* gLogStream;
extern bool gStopBlockerThread;
extern PGPreferences gPrefs;

} // namespace PG

#endif // PEERGUARD_HEADER___

