//
//  pgcurs (PeerGuard curses UI for Linux, BSD, and MacOS X systems)
//  Copyright (C) 2005 Nullcontext
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Id: pgtext.cpp,v 1.1 2005/03/27 07:39:25 nullcontext Exp $

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <curses.h>
#include <iostream>
#include <fstream>
#include <limits.h>

#define FIFO_NAME "/tmp/PG_fifo"
#define DEFAULT_BLOCKLIST "/etc/p2p.p2b.p2p"
#define DEFAULT_LOG "/var/log/PG.log"
#define DEFAULT_CONF "/etc/PG.conf"
#define DEFAULT_EDITOR "vi"
#define BUFFER_SIZE PIPE_BUF

void *stats_thread(void *arg);

// globals

// variable to hold request from client to kill thread
int response;

// various file name variables
char blocklist_name[25] = DEFAULT_BLOCKLIST;
char log_name[25] = DEFAULT_LOG;
char conf_name[25] = DEFAULT_CONF;
char editor_name[25] = DEFAULT_EDITOR;

using namespace std;
//
// This Function checks for a .pgcurs file and reads the 
// user variables stored in it if the file is found. 
//

void read_rc()
{
	ifstream myInit;
	char initLine[110]="";
	int counter=10;
	myInit.open(".pgcursrc", ifstream::in);
	if(myInit){
		myInit.getline(initLine, 110);
		if(initLine[0]=='B'){
			// get blocklist name
			while(counter !=35){ 
				blocklist_name[counter-10]=initLine[counter];
				counter++;
			}
			// get log name
			myInit.getline(initLine, 110);
			counter=4;
			while(counter !=35){
				log_name[counter-4]=initLine[counter];
				counter++;
			}
			// get conf name
			myInit.getline(initLine, 110);
			counter=5;
			while(counter !=35){
				conf_name[counter-5]=initLine[counter];
				counter++;
			}
			// get editor name 
			myInit.getline(initLine, 110);
			counter=7;
			while(counter !=35){
				editor_name[counter-7]=initLine[counter];
				counter++;
			}
		}
		else{
			printf("Problem with init file");
		}
	}
	else{
		printf("Problem with init file");
	}
	
	myInit.close();
}
//
// This Function writes out the .pgcursrc file 
//

void write_rc()
{
	ofstream myInit;
	char initLine[110]="", emptyLine[110]="";
	myInit.open(".pgcursrc", ifstream::out);
	if(myInit){
		// write out the name of the blocklist file
		strcpy(initLine, "BLOCKLIST=");
		strcat(initLine, blocklist_name);
		strcat(initLine, "\n");
		myInit.write(initLine, strlen(initLine));
		strcpy(initLine, emptyLine);
		// write out the name of the log file
		strcpy(initLine, "LOG=");
		strcat(initLine, log_name);
		strcat(initLine, "\n");
		// write out the name of the configuration file
		myInit.write(initLine, strlen(initLine));
		strcpy(initLine, emptyLine);
		strcpy(initLine, "CONF=");
		strcat(initLine, conf_name);
		strcat(initLine, "\n");
		// write out the name of the editor to use
		myInit.write(initLine, strlen(initLine));
		strcpy(initLine, emptyLine);
		strcpy(initLine, "EDITOR=");
		strcat(initLine, editor_name);
		strcat(initLine, "\n");
		myInit.write(initLine, strlen(initLine)); 
	}
	else{
		printf("Problem with init file");
	}
	
	myInit.close();
}
// 
// this function displays the information about the active running peerguardian 
// program
// 
void *stats_thread(void *arg){

	int mycount_x, logCount=0;
	long long int packet_check=0, packet_block=0;
	char logLine[200];
	int PG_pipe=0, my_response=0, stateamt=0, stateamt2=0;;
	char buffer[BUFFER_SIZE + 1], buffer2[BUFFER_SIZE + 1];	 
	memset(buffer, '\0', sizeof(buffer));
	
	PG_pipe = open(FIFO_NAME, O_RDONLY);
	
	while(response != 10){	
		// print stats
		ifstream logFile;
		logFile.open(log_name, ifstream::in);
		logCount=0;
		// This section checks the data passed in from the pipe and determines if the 
		// information was passed for a blocked packet or 1000 checked packets. 
		// Either 6 green stars or 6 red stars are then displayed to the user 
		// showing a blocked red state or a checking green state. 
		
		if(stateamt > packet_block){
			attrset(COLOR_PAIR(2));
			mvprintw(1, 57, "******");
			packet_block=stateamt;
			attrset(COLOR_PAIR(1));
			mvprintw(1, 56, " ");
			move(24,1);
			refresh();
		}else{
			attrset(COLOR_PAIR(2));
			mvprintw(1, 57, "      ");
			attrset(COLOR_PAIR(1));
			mvprintw(1, 56, " ");
			move(24,1);
			refresh();
		}
		if(stateamt2 > packet_check){
			attrset(COLOR_PAIR(3));
			mvprintw(1, 50, "******");
			attrset(COLOR_PAIR(1));
			mvprintw(1, 56, " ");
			packet_check=stateamt2;
			move(24,1);
			refresh();
		}
		else{
			attrset(COLOR_PAIR(2));
			mvprintw(1, 50, "      ");
			attrset(COLOR_PAIR(1));
			mvprintw(1, 56, " ");
			move(24,1);
			refresh();
		}
		attrset(COLOR_PAIR(1));
		
		// This section show the number packets blocked or the thousands of packets 
		// checked since the monitoring process began. 
		
		mvprintw(4, 10, "%s", "Packets Blocked");
		mvprintw(4, 40, "%s", "Packets Checked");
		mvprintw(5, 14, "%d", packet_block);			
		mvprintw(5, 44, "%d", packet_check);
		mvprintw(8, 30, "%s", "Blocked");
		
		// The last 10 entries in the log file are then displayed and
		// the rest of the screen is cleared. 
		
		while(logCount !=10){
			for(mycount_x=0;mycount_x < COLS; mycount_x++){
				attroff(A_BOLD);
				attrset(COLOR_PAIR(1));
				mvwaddch(stdscr, logCount+9, mycount_x, ' ');
			}
			logCount++;
		}
		logCount=0;
		while(logFile.getline(logLine, 199)) {
			if(logCount !=10){
				for(mycount_x=0;mycount_x < COLS; mycount_x++){
					attroff(A_BOLD);
					attrset(COLOR_PAIR(1));
					mvwaddch(stdscr, logCount+9, mycount_x, ' ');
				}
				mvprintw(9+logCount, 0, "%s", logLine);
				logCount++;
			}
			else{
				logCount=0;
			}
		}
		while(logCount != 20){
			for(mycount_x=0;mycount_x < COLS; mycount_x++){
				attroff(A_BOLD);
				attrset(COLOR_PAIR(1));
				mvwaddch(stdscr, logCount+9, mycount_x, ' ');
			}				
			logCount++;
		}
		
		attrset(COLOR_PAIR(2));
		mvprintw(24, 1, "%s", "BACK");
		move(24,1);
		refresh();
		strcpy(buffer,"");
		sleep(5);
		
		if(PG_pipe != -1){
			my_response=read(PG_pipe, buffer, BUFFER_SIZE);
			my_response=read(PG_pipe, buffer2, BUFFER_SIZE);
		
			sscanf(buffer, "PB%d", &stateamt);
			sscanf(buffer2, "PC%d", &stateamt2);
		}
		else{
			printf("ERROR OPENING PIPE");
		}
		logFile.close();
	}
	(void)close(PG_pipe);
	pthread_exit(NULL);
}
// 
// this function controls the thread that displays the stats for peerguardian
// 

void sub_monpg()
{  
	int mycount_x, mycount_y, thread_response;
	pthread_t a_thread;
	crmode();
	keypad(stdscr, TRUE);
	noecho();
	
	// paint the background for the thread and start the thread
	
	if(has_colors() && start_color() == OK){
				
		 
		init_pair(1, COLOR_BLUE, COLOR_WHITE);
		init_pair(2, COLOR_RED, COLOR_BLACK);
		init_pair(3, COLOR_GREEN, COLOR_BLACK);
		
				
		// fill the screen with a background color
		for(mycount_y=0; mycount_y < LINES; mycount_y++){
			for(mycount_x=0;mycount_x < COLS; mycount_x++){
			attroff(A_BOLD);
			attrset(COLOR_PAIR(1));
			mvwaddch(stdscr, mycount_y, mycount_x, ' ');			
			}
		}
		// paint the top
		refresh();
		attrset(COLOR_PAIR(1));
		mvprintw(1, 25, "%s", "PEERGUARDIAN v1.5beta");
		mvprintw(7, 25, "%s", "Please Wait ...");
		refresh();
		// start the thread
		sleep(5);
		mvprintw(7, 25, "%s", "               ");
		refresh();
		response=0;
		thread_response = pthread_create(&a_thread, NULL, stats_thread, NULL);
		if(thread_response != 0){
			perror("stats thread creation failed");
			exit(EXIT_FAILURE);
		}
						
		// paint the bottom
		attrset(COLOR_PAIR(2));
		mvprintw(24, 1, "%s", "BACK");
		move(24,1);
		refresh();
		response = 0;
		while(response != 10)
		response=getch();		
	} 
	else{
		printf("no color");
	} 
}
//
// this function gets the new name of the log file to use
//
void get_logfile_name(){
	WINDOW *popup_window_ptr;
	char new_name[25]="";
	int key=0, spot=4, counter=0;
	
	strcpy(log_name, new_name);
	popup_window_ptr = newwin(10,25,7,30);
	box(popup_window_ptr, '|', '-');
	
	// while the enter key is not pressed keep displaying the popup 
	// window and getting information from the user
	while(key != 10){
		mvwprintw(popup_window_ptr, 5, 2, "%s", "Enter Log File Name");
		mvwprintw(popup_window_ptr, 6, 2, "[ %s  ]", new_name);
		move(13, 30+spot);
		wrefresh(popup_window_ptr);
		key=getch();
		if(key != KEY_BACKSPACE){
			spot++;
			new_name[counter]=(char)key;
			counter++;
		}
		else{
			spot--;
			new_name[(counter-1)]=new_name[counter+1];
			mvwaddch(popup_window_ptr, 6, spot+3, ' ');
			counter--;
		}
	}
	new_name[(counter-1)]=new_name[counter+1];
	strcpy(log_name, new_name);
	write_rc();
	endwin();
} 
//
// this function gets the new name of the config file to use
//
void get_config_name(){
	WINDOW *popup_window_ptr;
	char new_name[25]="";
	int key=0, spot=4, counter=0;
	
	strcpy(conf_name, new_name);
	popup_window_ptr = newwin(10,25,7,30);
	box(popup_window_ptr, '|', '-');
	// while the enter key is not pressed keep displaying the popup 
	// window and getting information from the user
	while(key != 10){
		mvwprintw(popup_window_ptr, 5, 2, "%s", "Enter Config File Name");
		mvwprintw(popup_window_ptr, 6, 2, "[ %s  ]", new_name);
		move(13, 30+spot);
		wrefresh(popup_window_ptr);
		key=getch();
		if(key != KEY_BACKSPACE){
			spot++;
			new_name[counter]=(char)key;
			counter++;
		}
		else{
			spot--;
			new_name[(counter-1)]=new_name[counter+1];
			mvwaddch(popup_window_ptr, 6, spot+3, ' ');
			counter--;
		}
	}
	new_name[(counter-1)]=new_name[counter+1];
	strcpy(conf_name, new_name);
	write_rc();
	endwin();
} 
//
// this function gets the new name of the editor to use
//
void get_editor_name(){
	WINDOW *popup_window_ptr;
	char new_name[25]="";
	int key=0, spot=4, counter=0;
	
	strcpy(editor_name, new_name);
	popup_window_ptr = newwin(10,25,7,30);
	box(popup_window_ptr, '|', '-');
	// while the enter key is not pressed keep displaying the popup 
	// window and getting information from the user

	while(key != 10){
		mvwprintw(popup_window_ptr, 5, 2, "%s", "Enter Editor To Use");
		mvwprintw(popup_window_ptr, 6, 2, "[ %s  ]", new_name);
		move(13, 30+spot);
		wrefresh(popup_window_ptr);
		key=getch();
		if(key != KEY_BACKSPACE){
			spot++;
			new_name[counter]=(char)key;
			counter++;
		}
		else{
			spot--;
			new_name[(counter-1)]=new_name[counter+1];
			mvwaddch(popup_window_ptr, 6, spot+3, ' ');
			counter--;
		}
	}
	new_name[(counter-1)]=new_name[counter+1];
	strcpy(editor_name, new_name);
	write_rc();
	endwin();
} 

// 
// this function prints the user option menu modifies the appropriate system file
// and reloads peerguardian. 
// 
void menu_options()
{  
	int mycount_x, mycount_y, myselect=9;
	int key=0;
		 
	crmode();
	keypad(stdscr, TRUE);
	noecho();
	  
	if(has_colors() && start_color() == OK){
				
		 
		init_pair(1, COLOR_BLUE, COLOR_WHITE);
		init_pair(2, COLOR_RED, COLOR_BLACK);
				
		// fill the screen with a background color
		for(mycount_y=0; mycount_y < LINES; mycount_y++){
			for(mycount_x=0;mycount_x < COLS; mycount_x++){
			attroff(A_BOLD);
			attrset(COLOR_PAIR(1));
			mvwaddch(stdscr, mycount_y, mycount_x, ' ');			
			}
		}
		refresh();
		attrset(COLOR_PAIR(2));
		mvprintw(9, 33, "%s", "Change Log File"); 
		move(9,33);
   
		// print options the menu
		while(key!=10){
			attrset(COLOR_PAIR(1));
			mvprintw(2, 30, "%s", "PEERGUARDIAN v1.5beta");
			mvprintw(6, 33, "%s", "OPTIONS MENU");
			
			if(myselect != 9)
				mvprintw(9, 33, "%s", "Change Log File");	
			if(myselect != 10)
				mvprintw(10, 33, "%s", "Change Config File");
			if(myselect != 11)
				mvprintw(11, 33, "%s", "Change Editor");
			if(myselect != 12)
				mvprintw(12, 33, "%s", "Return to main menu");
			move(myselect, 33);
			
			key=getch();
			if(key == KEY_UP && myselect !=9)
				myselect--;
			else if(key == KEY_DOWN && myselect !=12)
				myselect++;
			switch(myselect){
			
			case 9:attrset(COLOR_PAIR(2));mvprintw(9, 33, "%s", "Change Log File");break;
			case 10:attrset(COLOR_PAIR(2));mvprintw(10, 33, "%s", "Change Config File");break;
			case 11:attrset(COLOR_PAIR(2));mvprintw(11, 33, "%s", "Change Editor");break;
			case 12:attrset(COLOR_PAIR(2));mvprintw(12, 33, "%s", "Return to main menu");break;
			}		
			refresh();
		}
		// based on the user selection call the subfunction to perform the selected
		// task
		switch(myselect){
		case 9:get_logfile_name();break;
		case 10:get_config_name();break;
		case 11:get_editor_name();break;
		}
	} 
	else{
		printf("no color");
	} 
	  
}

  
// 
// this function prints the user menu then gets the input and returns it. 
// 
int menu_main()
{  
	int mycount_x, mycount_y, myselect=8;
	int key=0;
		 
	crmode();
	keypad(stdscr, TRUE);
	noecho();
	  
	if(has_colors() && start_color() == OK){
				
		 
		init_pair(1, COLOR_BLUE, COLOR_WHITE);
		init_pair(2, COLOR_RED, COLOR_BLACK);
				
		// fill the screen with a background color
		for(mycount_y=0; mycount_y < LINES; mycount_y++){
			for(mycount_x=0;mycount_x < COLS; mycount_x++){
			attroff(A_BOLD);
			attrset(COLOR_PAIR(1));
			mvwaddch(stdscr, mycount_y, mycount_x, ' ');			
			}
		}
		refresh();
		attrset(COLOR_PAIR(2));
		mvprintw(8, 33, "%s", "Monitor PG");
		move(8,33);
   
		// print the main menu
		while(key!=10){
			attrset(COLOR_PAIR(1));
			mvprintw(2, 30, "%s", "PEERGUARDIAN v1.5beta");
			mvprintw(6, 33, "%s", "USER MENU");
			
			if(myselect != 8)
				mvprintw(8, 33, "%s", "Monitor PG");
			if(myselect != 9)
				mvprintw(9, 33, "%s", "Load/Unload PG");
			if(myselect != 10)
				mvprintw(10, 33, "%s", "Edit blocklist");			
			if(myselect != 11)
				mvprintw(11, 33, "%s", "Search list for ip");
			if(myselect != 12)
				mvprintw(12, 33, "%s", "Merge two lists");
			if(myselect != 13)
				mvprintw(13, 33, "%s", "Configure Options");
			if(myselect != 14)
				mvprintw(14, 33, "%s", "Exit");
			move(myselect, 33);
			
			key=getch();
			if(key == KEY_UP && myselect !=8)
				myselect--;
			else if(key == KEY_DOWN && myselect !=14)
				myselect++;
			switch(myselect){
			case 8:attrset(COLOR_PAIR(2));mvprintw(8, 33, "%s", "Monitor PG");break;
			case 9:attrset(COLOR_PAIR(2));mvprintw(9, 33, "%s", "Load/Unload PG");break;
			case 10:attrset(COLOR_PAIR(2));mvprintw(10, 33, "%s", "Edit blocklist");break;
			case 11:attrset(COLOR_PAIR(2));mvprintw(11, 33, "%s", "Search list for ip");break;
			case 12:attrset(COLOR_PAIR(2));mvprintw(12, 33, "%s", "Merge two lists");break;
			case 13:attrset(COLOR_PAIR(2));mvprintw(13, 33, "%s", "Configure Options");break;
			case 14:attrset(COLOR_PAIR(2));mvprintw(14, 33, "%s", "Exit");break;
			}		
			refresh();
		}
		return myselect;
	} 
	else{
		printf("no color");
		return false;
	} 
	 
}
//
// this function loads/unloads peerguardian
//
void peerguardian_reloaded(){
	WINDOW *popup_window_ptr;
	int key=0, load_select=3;
	char system_cmd[100]="";
	
	crmode();
	keypad(stdscr, TRUE);
	noecho();
		
	popup_window_ptr = newwin(10,20,7,30);
	box(popup_window_ptr, '|', '-');
	// while the enter key is not pressed keep displaying the popup 
	// window and getting information from the user

	while(key != 10){
		mvwprintw(popup_window_ptr, 3, 2, "%s", "Load PG   ( )");
		mvwprintw(popup_window_ptr, 5, 2, "%s", "Unload PG ( )");
		mvwprintw(popup_window_ptr, 7, 2, "%s", "Go Back   ( )");
		if(key == KEY_UP && load_select !=3){
			load_select=load_select-2;
		}
		else if(key == KEY_DOWN && load_select !=7){
			load_select=load_select+2;
		}
		
		move(load_select+7, 43);
		wrefresh(popup_window_ptr);
		key=getch();
	}
	
	
	// based on the user selection either load or unload peerguardian 
	// as root
	if(load_select == 3){
		endwin();
		strcpy(system_cmd,"su -c \"peerguardnf -c ");
		strcat(system_cmd,conf_name);
		strcat(system_cmd," -l ");
		strcat(system_cmd, log_name);
		strcat(system_cmd, " -d -m\"");
		system("echo Please Enter Root Password to Load PG");
		system(system_cmd);
	}
	else if(load_select == 5){
		endwin();
		system("echo Please Enter Root Password to UnLoad PG");
		system("su -c \"killall peerguardnf\"");
	}
}
//
// this function uses peerguardian to search the blocklist for an ip
//
void peerguardian_searchip(){
	WINDOW *popup_window_ptr;
	char sys_string[75]="peerguardnf ", search_ip[50]="";
	int key=0, spot=4, counter=30;
	crmode();
	keypad(stdscr, TRUE);
		
	strcat(sys_string, "-i ");
	 
	popup_window_ptr = newwin(10,25,7,30);
	box(popup_window_ptr, '|', '-');
	// while the enter key is not pressed keep displaying the popup 
	// window and getting information from the user

	while(key != 10){
		mvwprintw(popup_window_ptr, 5, 2, "%s", "Search IP");
		mvwprintw(popup_window_ptr, 6, 2, "[ %s  ]", search_ip);
		move(13, 30+spot);
		wrefresh(popup_window_ptr);
		key=getch();
		if(key != KEY_BACKSPACE){
			spot++;
			sys_string[counter]=(char)key;
			if(key != '\n')
			search_ip[(counter-30)]=(char)key;
			counter++;
		}
		else{
			spot--;
			sys_string[counter-1]=sys_string[counter+1];
			search_ip[(counter-31)]=search_ip[(counter-29)];
			mvwaddch(popup_window_ptr, 6, spot+3, ' ');
			counter--;
		}
	}
	endwin();
	strcat(sys_string, search_ip);
	strcat(sys_string, " ");
        strcat(sys_string, blocklist_name);
	
	system(sys_string);
	sleep(2);
}
//
// this function uses peerguardian merge two lists
//
void peerguardian_merge(){
	WINDOW *popup_window_ptr;
	char sys_string[100]="peerguardnf ", merge_source[50]="", merge_dest[50]="";
	int key=0, spot=4, counter=14, counter2=0;
	crmode();
	keypad(stdscr, TRUE);
		
	popup_window_ptr = newwin(10,25,7,30);
	box(popup_window_ptr, '|', '-');
	// while the enter key is not pressed keep displaying the popup 
	// window and getting information from the user for the merge source

	while(key != 10){
		mvwprintw(popup_window_ptr, 2, 2, "%s", "Source List");
		mvwprintw(popup_window_ptr, 6, 2, "%s", "Desination List");
		mvwprintw(popup_window_ptr, 4, 2, "[ %s  ]", merge_source);
		move(11, 30+spot);
		wrefresh(popup_window_ptr);
		key=getch();
		if(key != KEY_BACKSPACE){
			spot++;
			sys_string[counter]=(char)key;
			if(key != '\n')
			merge_source[(counter-14)]=(char)key;
			counter++;
		}
		else{
			spot--;
			sys_string[counter-1]=sys_string[counter+1];
			merge_source[(counter-15)]=merge_source[(counter-13)];
			mvwaddch(popup_window_ptr, 4, spot+3, ' ');
			counter--;
		}
	}
	strcat(sys_string, merge_source);
	strcat(sys_string, " ");
	// insert -f in between the two file names
	counter--;
	strcat(sys_string, "-f ");
	counter+=4;
	spot=4;
	key=0;
	// while the enter key is not pressed keep displaying the popup 
	// window and getting information from the user for the destination
	// merge file name. 

	while(key != 10){
		mvwprintw(popup_window_ptr, 8, 2, "[ %s  ]", merge_dest);
		move(15, 30+spot);
		wrefresh(popup_window_ptr);
		key=getch();
		if(key != KEY_BACKSPACE){
			spot++;
			sys_string[counter]=(char)key;
			if(key != '\n')
			merge_dest[(counter2)]=(char)key;
			counter++;
			counter2++;
		}
		else{
			spot--;
			sys_string[counter-1]=sys_string[counter+1];
			merge_dest[(counter2-1)]=merge_dest[(counter2+1)];
			mvwaddch(popup_window_ptr, 8, spot+3, ' ');
			counter--;
			counter2--;
		}
	}
	endwin();
	strcat(sys_string, merge_dest);
	// perform the merge
	
	system(sys_string);
	sleep(2);
}
//
// this function loads the editor
//
void load_editor(){
	char system_command[100] = "";
	
	strcpy(system_command,editor_name);
	strcat(system_command, " ");
	strcat(system_command,blocklist_name);
	system(system_command);
	endwin();
}
//
// main controlling function
//
int main(){
	int menu_sel=0;

	
	read_rc();
	
	
	
	// initialize the screen
	initscr();
	refresh();
	
	while(menu_sel !=14){
		// call the main menu to display the menu to find out what action
		// the user wants to perform. 
		initscr();
		refresh();	
		menu_sel=menu_main();
                
		// call up the sub function to perform the action specified. 
		switch(menu_sel){
		case 8:sub_monpg();break;
		case 9:peerguardian_reloaded();break;
		case 10:load_editor();break;
		case 11:peerguardian_searchip();break;
		case 12:endwin();peerguardian_merge();break;
		case 13:endwin();menu_options();break;
		}                                                                      
		
	}	                                                                                             
	                                                                                               
	// exit gracefully                                                                             
	endwin();      
	
	printf("Shutting down Peerguardian Interface\n");                                              
	exit(0);                                                                                       
}	
